<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 29/06/12
 * Time: 10:36
 * To change this template use File | Settings | File Templates.
 */
 
class RegistroDadosIniciaisHomolognet extends RegistroHomolognet {

                                                                                     //  Layout    Arquivo
    const DADOS_INICIAIS = 'DadosIniciais';
    const JORNADA_CUMPRIDA_INTEGRAL = 'TPJornadaCumpridaIntegralmente';                   // A         A
    const JORNADA_SEMANA = 'TPJornadaSemana';                                             // B         B
    const FORMA_CALCULO = 'FormaCalculo';
    const CALCULO_MEDIAS_VARAIVEIS_13SAL = 'TPCalculoMediasVariaveisDecimoTerceiro';      // C         D
    const DECIMO_TERCEIRO = 'TPDecimoTerceiro';                                           // D         E
    const QTD_13SAL_ULTIMOS_MESES = 'NRDecimoTerceiroUltimosMesesQuantidade';             // E         F
    const MAIORES_13SAL_ULTIMOS_MESES = 'NRDecimoTerceiroUltimosMesesMaiores';            // F         G
    const CALCULO_MEDIAS_VARIAVEIS_FERIAS = 'TPCalculoMediasVariaveisFerias';             // G         H
    const FERIAS = 'TPFerias';                                                            // H         I
    const QTD_FERIAS_ULTIMOS_MESES = 'NRFeriasUltimosMesesQuantidade';                    // I         J
    const MAIORES_FERIAS_ULTIMOS_MESES = 'NRFeriasUltimosMesesMaiores';                   // J         K
    const CALCULO_MEDIAS_VARIAVEIS_AVISO_PREVIO = 'TPCalculoMediasVariaveisAvisoPrevio';  // K         L
    const QTD_AVISO_PREVIO_ULTIMOS_MESES = 'NRAvisoPrevioUltimosMesesQuantidade';         // L         M
    const MAIORES_AVISO_PREVIO_ULTIMOS_MESES = 'NRAvisoPrevioUltimosMesesMaiores';        // M         N
    const DURACAO_AVISO_PREVIO = 'NRDuracaoAvisoPrevio';                                  // N         C
    const SIM = 'S';

    private $dadosIniciasForm;

    public function geraRegistroDadosIniciais($dadosInciaisForm){
        $this->dadosIniciasForm = $dadosInciaisForm;
        $this->_geraRegistro();
    }


    private function _geraRegistro(){
        parent::geraRegistro(null, null, null);

        // Campo A - tamanho 01 - Jornada de trabalho da semana cumprida integral (1-SIM / 2-NAO)
        $this->_atribuiJornadaTrabalhoSemanal();

        // Campo B - tamanho 01 - Jornada de trabalho do sabado compensada na semana (1-SIM / 2-NAO)
        $this->_atribuiJornadaTrabalhoSabado();

        // Atribuicao da tag Forma Calculo
        $tag = self::FORMA_CALCULO;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        // Campo C - tamanho 01 - Forma de calculo das medias das verbas salariais variaveis: 13 Salario (1-CLT / 2-Convencional)
        $this->_atribuiFormaCalculo13Salario();

        // Campo D - tamanho 01 - Forma de Apuração da Base de Cálculo do 13º Salário
        $this->_atribuiDecimoTerceiroSalario();

        // Campo E - tamanho 02 - Quantidade de meses para apuracao da base de calculo do 13 Salario
        $this->_atribui13SalarioUltimosMeses();

        // Campo F - tamanho 02 - Informar para quantos dos meses informados acima deverao ser considerados os maiores valores.
        $this->_atribuiMaiores13SalarioUltimosMeses();

        // Campo G - tamanho 01 - Forma de Cálculo das Médias das Verbas Salariais Variáveis: Férias. (1 = CLT / 2 = Convencionado)
        $this->_atribuiFormaCalculoFerias();

        // Campo H - tamanho 01 - Forma de Apuração da Base de Cálculo das Férias
        $this->_atribuiFerias();

        // Campo I - tamanho 02 - Quantidade de meses para apuracao da base de calculo das Ferias
        $this->_atribuiFeriasUltimosMeses();

        // Campo J - tamanho 02 - Informar para quantos dos meses informados acima deverao ser considerados os maiores valores.
        $this->_atribuiMaioresFeriasUltimosMeses();

        // Campo K - tamanho 01 - Forma de Cálculo das Médias das Verbas Salariais Variáveis: Aviso Prévio (1 = CLT / 2 = Convencionado)
        $this->_atribuiFormaCalculoAvisoPrevio();

        // Campo L - tamanho 02 - Quantidade de meses para a apuração da Base de Cálculo do Aviso Prévio.
        $this->_atribuiAvisoPrevioUltimosMeses();

        // Campo M - tamanho 02 - Informar para quantos dos meses informados acima deverao ser considerados os maiores valores.
        $this->_atribuiMaioresAvisoPrevioUltimosMeses();

        // Campo N - tamanho 03 - Duração do Aviso Prévio.
        $this->_atribuiDuracaoAvisoPrevio();

        $tag = parent::CARACTER_FINALIZADOR;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

    }

    
    private function _atribuiJornadaTrabalhoSemanal(){
        if ($this->dadosIniciasForm['JORNADATRABINT'] == self::SIM) {
            $dado = '1';
        } else {
            $dado = '2';
        }
        $tag = self::JORNADA_CUMPRIDA_INTEGRAL.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
    }


    private function _atribuiJornadaTrabalhoSabado(){
        if ($this->dadosIniciasForm['JORNADATRABAFAST'] == self::SIM) {
            $dado = '1';
        } else {
            $dado = '2';
        }
        $tag = self::JORNADA_SEMANA.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
    }

    
    private function _atribuiFormaCalculo13Salario(){

        $dado = $this->dadosIniciasForm['FORMACALCMEDIAS'];
        if (empty($dado) === false) {
            $tag = self::CALCULO_MEDIAS_VARAIVEIS_13SAL.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }
    }


    private function _atribuiDecimoTerceiroSalario(){
        /* D.1. Optar por (domínio): Últimos meses / Ano Corrente (todos os meses do ano corrente)
         * D.2. Esta informação será aplicada a todos os trabalhadores relacionados no arquivo.
         * D.3. Este campo será obrigatório, caso campo C = 2.
         */
        $dado = $this->dadosIniciasForm['FORMABASE13SALARIO'];
        if (empty($dado) === false) {
            $tag = self::DECIMO_TERCEIRO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }

    }


    private function _atribui13SalarioUltimosMeses(){
       /* E.1. Este campo terá sua ocorrência condicionada e correspondente ao campo D = 1 para a Base de Cálculo de 13º Salário.
        * E.2. Nesta situação de obrigatoriedade, não aceita valor nulo.
        */
        $dado = $this->dadosIniciasForm['QUANTMESES13SALARIO'];
        if (empty($dado) === false) {
            $tag = self::QTD_13SAL_ULTIMOS_MESES.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2);
        }
    }


    private function _atribuiMaiores13SalarioUltimosMeses(){
       /* F.1. Este campo corresponde de forma combinada à Base de Cálculo de 13º Salário (campo D = 1) e está vinculado à quantidade informada no campo E.
        * F.2. Este campo, se preenchido, não aceita valor = 0.
        */
        $dado = $this->dadosIniciasForm['QUANTMESESMAIORES13'];
        if (empty($dado) === false) {
            $tag = self::MAIORES_13SAL_ULTIMOS_MESES.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2);
        }

    }


    private function _atribuiFormaCalculoFerias(){
        $dado = $this->dadosIniciasForm['FORMACALCMEDFERIAS'];
        if (empty($dado) === false) {
            $tag = self::CALCULO_MEDIAS_VARIAVEIS_FERIAS.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }

    }


    private function _atribuiFerias(){
       /* H.1. Optar por (domínio): 1 = Últimos meses / 2 = Período Aquisitivo
        * H.2. Esta informação será aplicada a todos os trabalhadores relacionados no arquivo.
        * H.3. Este campo será obrigatório, caso campo G = 2. Nesta situação, não aceita valor nulo.
        */
        $dado = $this->dadosIniciasForm['FORMAAPURACAOFERIAS'];
        if (empty($dado) === false) {
            $tag = self::FERIAS.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }
    }


    private function _atribuiFeriasUltimosMeses(){
       /* I.1. Este campo terá sua ocorrência condicionada e correspondente ao campo H = 1 para a Base de Cálculo de Férias.
        * I.2. Nesta situação de obrigatoriedade, não aceita valor nulo.
        */
        $dado = $this->dadosIniciasForm['QUANTMESESFERIAS'];
        if (empty($dado) === false) {
            $tag = self::QTD_FERIAS_ULTIMOS_MESES.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2);
        }
    }


    private function _atribuiMaioresFeriasUltimosMeses(){
       /* J.1. Este campo corresponde de forma combinada à Base de Cálculo de Férias (campo H=1) e está vinculado à quantidade informada no campo I.
        * J.2. Este campo, se preenchido, não aceita valor = 0.
        */
        $dado = $this->dadosIniciasForm['QUANTMESESMAIORESFERIAS'];
        if (empty($dado) === false) {
            $tag = self::MAIORES_FERIAS_ULTIMOS_MESES.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2);
        }
    }


    private function _atribuiFormaCalculoAvisoPrevio(){
       /* J.1. Este campo corresponde de forma combinada à Base de Cálculo de Férias (campo H=1) e está vinculado à quantidade informada no campo I.
        * J.2. Este campo, se preenchido, não aceita valor = 0.
        */
        $dado = $this->dadosIniciasForm['FORMACALCMEDAVISOPREVIO'];
        if (empty($dado) === false) {
            $tag = self::CALCULO_MEDIAS_VARIAVEIS_AVISO_PREVIO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }
    }


    private function _atribuiAvisoPrevioUltimosMeses(){
       /* L.1. Este campo somente ser á obrigatório, caso campo K = 2. Nesta situação, não aceita valor nulo.
        * L.2. Esta informação será aplicada a todos os trabalhadores relacionados no arquivo.
        */
        $dado = $this->dadosIniciasForm['QUANTMESESAVISOPREVIO'];
        if (empty($dado) === false) {
            $tag = self::QTD_AVISO_PREVIO_ULTIMOS_MESES.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2);
        }
    }


    private function _atribuiMaioresAvisoPrevioUltimosMeses(){
       /* M.1. Este campo corresponde à Base de Cálculo do Aviso Prévio e está vinculado à quantidade informada no campo L.
        * M.2. Este campo, se preenchido, não aceita valor = 0.
        */
        $dado = $this->dadosIniciasForm['QUANTMESESMAIORESAVISOPREVIO'];
        if (empty($dado) === false) {
            $tag = self::MAIORES_AVISO_PREVIO_ULTIMOS_MESES.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2);
        }
    }


    private function _atribuiDuracaoAvisoPrevio(){
       // Este campo será obrigatório, caso campo K = 2.
        $dado = $this->dadosIniciasForm['DURACAOAVISOPREVIO'];
        $dado = str_replace('.','',$dado);
        if (empty($dado) === false) {
            $tag = self::DURACAO_AVISO_PREVIO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 3);
        }
    }

}