IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'APURAC_RETROATIVO_GD' AND
                 TYPE = 'P' 			             AND
                 U.UID = O.UID             	    AND
                 U.NAME = USER)
DROP PROCEDURE APURAC_RETROATIVO_GD
GO
CREATE PROCEDURE APURAC_RETROATIVO_GD
(
   @P_CDFILIFATU    VARCHAR(04),
   @P_NRAPURACFAT   VARCHAR(10),
   @P_DTINIAPURAC   DATETIME,
   @P_DTFIMAPURAC   DATETIME,
   @P_CDFILIAL      VARCHAR(04),
   @P_DTPROC        DATETIME,
   @P_PRXAPURACFAT  VARCHAR(10) OUTPUT
)
AS

      DECLARE @DOVRSERV      FLOAT;
      DECLARE @DOVRSERVATUAL FLOAT;
      DECLARE @V_CDTIPOOPER        VARCHAR(02);
      DECLARE @V_NRLANCTONF        VARCHAR(20);
      DECLARE @V_CDEMPRESA         VARCHAR(02);
      DECLARE @V_IDFATUPLAN        VARCHAR(01);
      DECLARE @STIDTIPNFEMP        VARCHAR(01);
      DECLARE @V_CDTURNO           VARCHAR(01);
      DECLARE @V_CDINSCMUNI        VARCHAR(16);
      DECLARE @V_CDINSCESTA        VARCHAR(16);
      DECLARE @V_CDSERIE           VARCHAR(05);
      DECLARE @V_CDPRODUTO         VARCHAR(10);
      DECLARE @V_CDSERVFILI        VARCHAR(05);
      DECLARE @V_NMSERVICO         VARCHAR(40);
      DECLARE @V_IDTPIJURCLIE      VARCHAR(01);
      DECLARE @V_NRINSJURCLIE      VARCHAR(20);
      DECLARE @V_IDSERIEAUTO       VARCHAR(01);
      DECLARE @V_CDCLIENTE         VARCHAR(21);
      DECLARE @P_NEWAPURACFAT      VARCHAR(20);
      DECLARE @V_VRSERVICO         FLOAT;
      DECLARE @V_QTEFETSERV        FLOAT;
      DECLARE @V_VRSERVTOTAL       FLOAT;
      DECLARE @V_STIDTIPNFEMP      VARCHAR(01);
      DECLARE @V_IDUTPROPEMIS      VARCHAR(01);
      DECLARE @V_CDTIPOFATUR       VARCHAR(03);
      DECLARE @V_CDPRODPRESTSERV   VARCHAR(10);
      DECLARE @V_TTITENSNF         FLOAT;
      DECLARE @V_PRXLANCESTQ       VARCHAR(10);
      DECLARE @V_CDARVPROD         VARCHAR(20);
      DECLARE @V_NMPRODUTO         VARCHAR(50);
      DECLARE @V_TEXT              VARCHAR(50);
	  DECLARE @V_IDMINIEFET        VARCHAR(01);
	  DECLARE @V_EXISTE            FLOAT;
	  DECLARE @V_CDCLIENTE_OLD     VARCHAR(21);
	  DECLARE @P_CONCAT            VARCHAR(100)
      /*VARIVEIS DO CURSOR CURS_APURAC*/
      DECLARE @CURS_APURAC_CDFILIAL VARCHAR(04);
      DECLARE @CURS_APURAC_CDCLIENTE VARCHAR(21);
      DECLARE @CURS_APURAC_CDSERVFILI VARCHAR(05);
      DECLARE @CURS_APURAC_DTEFETCLIE DATETIME;
      DECLARE @CURS_APURAC_QTCOMEFETCLI FLOAT;
      
      /*VARIAVEIS DO CURSOR CURS_TRAB*/
	  DECLARE @CURS_TRAB_CDCLIENTEAPGD VARCHAR(21);
	  DECLARE @CURS_TRAB_CDSERVFILIAPGD VARCHAR(05);
	  DECLARE @CURS_TRAB_VRPRECUNITAPGD FLOAT;
      DECLARE @CURS_TRAB_NREFETIVOSAPGD FLOAT;
      DECLARE @CURS_TRAB_NRAPURACGD     VARCHAR(10);
      DECLARE @CURS_TRAB_DTAPURACFATGD  DATETIME;
             
             
      /*CONTROLE DE GERACAO DA NOTA*/
      DECLARE @V_CTRL_PRODUTO INT;
      DECLARE @V_CTRL_CORPO INT;
      DECLARE @V_QTAPUR INT;
      DECLARE @V_DATA DATETIME;
BEGIN
   SET @V_QTAPUR = 0;
   SET @V_CTRL_PRODUTO = 0;
   SET @V_CTRL_CORPO = 1;

   SELECT @V_CDTIPOFATUR = MAX(CDTIPOFATUR), @V_IDMINIEFET = MAX(SUBSTRING(DSPARAMFATFI,01,1))
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_CDFILIAL;

   IF (@V_IDMINIEFET IS NULL) OR (@V_IDMINIEFET = ' ') BEGIN
      SET @V_IDMINIEFET = '1';
      -- POR DIA
   END;

   /* APAGA OS REGISTROS DA TRAB_APURAC_GD DE APURACOES ANTERIORES */
   DELETE FROM TRAB_APURAC_GD
   WHERE CDFILIALAPGD  = @P_CDFILIFATU  AND
         NRAPURACGD    = @P_NRAPURACFAT;

   IF ((@V_CDTIPOOPER IS NULL) OR (@V_CDTIPOOPER = '') OR (@V_CDTIPOOPER = ' ')) BEGIN
      SET @V_CDTIPOOPER = '01';
   END;

   DECLARE CURS_APURAC CURSOR FOR SELECT CDFILIAL, CDCLIENTE, CDSERVFILI, DTEFETCLIE, SUM(QTCOMEFETCLI) AS QTCOMEFETCLI
									FROM(SELECT CDFILIAL, CDCLIENTE, CDSERVFILI, DTEFETCLIE, QTCOMEFETCLI
										   FROM EFETCLIE
										  WHERE CDFILIFATU = @P_CDFILIFATU
											AND NRAPURACFAT = @P_NRAPURACFAT
										  UNION ALL
										 SELECT CDFILIAL, CDCLIENTE, CDSERVFILI, DTFATURAM AS DTEFETCLIE, QTCOMEFATU AS QTCOMEFETCLI
										   FROM EFECLIFAT
										  WHERE CDFILIFATU = @P_CDFILIFATU
											AND NRAPURACFAT = @P_NRAPURACFAT) APUR
								GROUP BY CDFILIAL, CDCLIENTE, CDSERVFILI, DTEFETCLIE
								ORDER BY CDCLIENTE, CDSERVFILI, DTEFETCLIE;

   OPEN CURS_APURAC;
   FETCH NEXT FROM CURS_APURAC INTO @CURS_APURAC_CDFILIAL, @CURS_APURAC_CDCLIENTE,
                                    @CURS_APURAC_CDSERVFILI, @CURS_APURAC_DTEFETCLIE,@CURS_APURAC_QTCOMEFETCLI ;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SELECT @V_IDFATUPLAN = SUBSTRING(MAX(IDFATUPLAN),1,1), @V_CDTURNO = SUBSTRING(MAX(CDTURNO),1,4), @V_CDPRODUTO = SUBSTRING(MAX(CDPRODUTO),1,10),
             @V_CDSERVFILI = SUBSTRING(MAX(CDSERVFILI),1,5), @V_NMSERVICO = SUBSTRING(MAX(NMSERVICO),1,400)
      FROM SUM_EFETIVOS
      WHERE DTFATURAM BETWEEN @P_DTINIAPURAC AND @P_DTFIMAPURAC AND
            CDFILIAL   = @P_CDFILIFATU AND
            CDCLIENTE  = @CURS_APURAC_CDCLIENTE AND
            CDSERVFILI = @CURS_APURAC_CDSERVFILI;

      SET @DOVRSERV = 0;
      SET @DOVRSERVATUAL = 0;
      SET @DOVRSERV = TEKNISA.CalcValrServ(@CURS_APURAC_CDFILIAL, @CURS_APURAC_CDCLIENTE,
                                           @CURS_APURAC_CDSERVFILI, @CURS_APURAC_DTEFETCLIE, @V_CDTURNO);

      SET @DOVRSERVATUAL = TEKNISA.CalcValrServ(@CURS_APURAC_CDFILIAL, @CURS_APURAC_CDCLIENTE,
                                                @CURS_APURAC_CDSERVFILI, GETDATE(), @V_CDTURNO);
	  
	  /* CALCULA O MINIMO DE EFETIVOS */
	  
	  SET @V_QTEFETSERV = @CURS_APURAC_QTCOMEFETCLI;

      IF (@DOVRSERVATUAL > @DOVRSERV) AND (@V_QTEFETSERV > 0 )BEGIN
         SET @V_VRSERVICO = @DOVRSERVATUAL - @DOVRSERV;

         SELECT @V_EXISTE = COUNT(*)
         FROM TRAB_APURAC_GD
         WHERE CDFILIALAPGD   = @P_CDFILIFATU
           AND NRAPURACGD     = @P_NRAPURACFAT
           AND CDCLIENTEAPGD  = @CURS_APURAC_CDCLIENTE
           AND CDSERVFILIAPGD = @CURS_APURAC_CDSERVFILI
           AND VRPRECUNITAPGD = @V_VRSERVICO;
           
         IF (@V_EXISTE = 0) BEGIN
            INSERT INTO TRAB_APURAC_GD(
               CDFILIALAPGD, CDCLIENTEAPGD, CDSERVFILIAPGD, VRPRECUNITAPGD,
               NREFETIVOSAPGD, NRAPURACGD, DTAPURACFATGD)
            VALUES(@P_CDFILIFATU, @CURS_APURAC_CDCLIENTE, @CURS_APURAC_CDSERVFILI, @V_VRSERVICO,
               @V_QTEFETSERV, @P_NRAPURACFAT, @P_DTPROC);  
         END ELSE BEGIN
            UPDATE TRAB_APURAC_GD
            SET NREFETIVOSAPGD = NREFETIVOSAPGD + @V_QTEFETSERV
         WHERE CDFILIALAPGD   = @P_CDFILIFATU
           AND NRAPURACGD     = @P_NRAPURACFAT
           AND CDCLIENTEAPGD  = @CURS_APURAC_CDCLIENTE
           AND CDSERVFILIAPGD = @CURS_APURAC_CDSERVFILI
           AND VRPRECUNITAPGD = @V_VRSERVICO;

         END;
      END;
      FETCH NEXT FROM CURS_APURAC INTO @CURS_APURAC_CDFILIAL    , @CURS_APURAC_CDCLIENTE ,
                                       @CURS_APURAC_CDSERVFILI  , @CURS_APURAC_DTEFETCLIE,
                                       @CURS_APURAC_QTCOMEFETCLI;
   END;
   CLOSE CURS_APURAC;
   DEALLOCATE CURS_APURAC;
   
   SET @V_CDCLIENTE_OLD = '';       

   DECLARE CURS_TRAB CURSOR FOR SELECT CDCLIENTEAPGD, CDSERVFILIAPGD, VRPRECUNITAPGD,
                                       NRAPURACGD, DTAPURACFATGD, SUM(NREFETIVOSAPGD) AS NREFETIVOSAPGD
                                  FROM TRAB_APURAC_GD
                                 WHERE CDFILIALAPGD = @P_CDFILIFATU
                                   AND NRAPURACGD = @P_NRAPURACFAT
                              GROUP BY CDCLIENTEAPGD, CDSERVFILIAPGD, VRPRECUNITAPGD,
                                       NRAPURACGD, DTAPURACFATGD
                              ORDER BY CDCLIENTEAPGD
   OPEN CURS_TRAB;
   FETCH NEXT FROM CURS_TRAB INTO @CURS_TRAB_CDCLIENTEAPGD, @CURS_TRAB_CDSERVFILIAPGD, @CURS_TRAB_VRPRECUNITAPGD, 
                                  @CURS_TRAB_NRAPURACGD   , @CURS_TRAB_DTAPURACFATGD , @CURS_TRAB_NREFETIVOSAPGD;
   WHILE (@@FETCH_STATUS = 0) BEGIN 	
      
      SELECT @V_IDFATUPLAN = SUBSTRING(MAX(IDFATUPLAN), 1, 1), @V_CDTURNO = SUBSTRING(MAX(CDTURNO), 1, 4), @V_CDPRODUTO = SUBSTRING(MAX(CDPRODUTO), 1, 10),
             @V_CDSERVFILI = SUBSTRING(MAX(CDSERVFILI), 1, 5), @V_NMSERVICO = SUBSTRING(MAX(NMSERVICO), 1, 400)
      FROM SUM_EFETIVOS
      WHERE DTFATURAM BETWEEN @P_DTINIAPURAC AND @P_DTFIMAPURAC AND
            CDFILIAL   = @P_CDFILIAL AND
            CDCLIENTE  = @CURS_TRAB_CDCLIENTEAPGD AND
            CDSERVFILI = @CURS_TRAB_CDSERVFILIAPGD;

      IF @V_CDCLIENTE_OLD <> @CURS_TRAB_CDCLIENTEAPGD BEGIN
         SET @V_CTRL_CORPO = 1;
      END;

      SET @V_CTRL_PRODUTO = 1;
      SET @V_QTAPUR = @V_QTAPUR + 1;
      SET @V_CDCLIENTE = @CURS_TRAB_CDCLIENTEAPGD;
      SET @V_VRSERVICO = @CURS_TRAB_VRPRECUNITAPGD;

      /* BUSCA AS INFORMAOES PARA CADASTRAMENTO DA NOTA FISCAL */
      SELECT @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCMUNI = MAX(CDINSCMUNI), @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDSERIE = MAX(CDSERIE)
      FROM FILIAL
      WHERE CDFILIAL = @P_CDFILIAL;

      SELECT @V_IDSERIEAUTO = ISNULL(MAX(IDSERIEAUTO), 'N')
      FROM TIPOOPERAC
      WHERE CDTIPOOPER   = @V_CDTIPOOPER AND
            IDENTRSAIDOP = 'S';

      IF @V_IDSERIEAUTO = 'S' BEGIN
         SELECT @V_CDSERIE = MAX(P.CDSERIE) 
         FROM PARAMSERIE P, FILIAL F, CLIENTE C
         WHERE F.CDFILIAL      = @P_CDFILIAL AND
               ISNULL(F.CDFILIFISC, F.CDFILIAL) = @P_CDFILIAL AND
               P.CDEMPRESA     = @V_CDEMPRESA  AND
               P.CDINSCESTA    = @V_CDINSCESTA AND
               P.CDINSCMUNI    = @V_CDINSCMUNI AND
               P.CDTIPOOPER    = @V_CDTIPOOPER AND
               C.CDCLIENTE     = @V_CDCLIENTE  AND
               P.CDCONDICAOIVA = C.CDCONDIVACLI AND
               P.IDENTRSAIDOP  = 'S';
      END;

      /* BUSCA OS PARAMETROS DA PARAMGERAL E PARAMFILIAL */
      SELECT @V_STIDTIPNFEMP = MAX(SUBSTRING(DSPARAMFATGE,11,1)), @V_IDUTPROPEMIS = ISNULL(MAX(IDUTPROPEMIS),'N'), 
             @V_CDPRODPRESTSERV = MAX(SUBSTRING(DSPARAMFATGE,1,10))
      FROM PARAMGERAL;

      IF @V_CDTIPOFATUR = '002' BEGIN
         SET @STIDTIPNFEMP = '1';

         SELECT @V_CDPRODPRESTSERV = MAX(SUBSTRING(DSPARAMFATGE,12,10)) 
         FROM PARAMGERAL;
      END ELSE BEGIN
         IF (@STIDTIPNFEMP IS NULL) OR (RTRIM(@STIDTIPNFEMP) = '') BEGIN
            SET @STIDTIPNFEMP = '2';
            -- REFEIO
         END;
      END;

      /* EFETUA O CADASTRAMENTO DO SERVICOS NA TABELA DE NOTA E ITENS */
      SELECT @V_TTITENSNF = ISNULL(MAX(NRMAXITNF),10) 
      FROM SERIENF
      WHERE CDEMPRESA  = @V_CDEMPRESA  AND
            CDINSCESTA = @V_CDINSCESTA AND
            CDINSCMUNI = @V_CDINSCMUNI AND
            CDSERIE    = @V_CDSERIE;

      SELECT @V_IDTPIJURCLIE = MAX(IDTPIJURCLIE), @V_NRINSJURCLIE = MAX(NRINSJURCLIE) 
      FROM CLIENTE
      WHERE CDCLIENTE = @V_CDCLIENTE;

      SELECT @V_CDARVPROD = MAX(CDARVPROD), @V_NMPRODUTO = MAX(NMPRODUTO)
      FROM PRODUTO
      WHERE CDPRODUTO = @V_CDPRODPRESTSERV;
      SET @P_CONCAT = 'APURACFATUR' + @P_CDFILIFATU;
      IF @V_CTRL_CORPO = 1 BEGIN
         EXEC TEKNISA.NOVO_CODIGO @P_CONCAT , @P_SEQUENCIAL = @P_NEWAPURACFAT OUTPUT;
         SET @P_NEWAPURACFAT = SUBSTRING(@P_NEWAPURACFAT, 11, 10);
		 SET @V_DATA = GETDATE();
         EXEC TEKNISA.GERA_NOTAFISCAL_CORPO  @P_CDFILIFATU, @P_CDFILIAL         ,  @V_CDEMPRESA,
                                             @V_CDTIPOOPER, @V_CDSERIE          ,  @V_CDCLIENTE,
                                             @V_DATA      , 'FAI'               ,  'N'         , 
                                             NULL         , @V_NRLANCTONF       ,  NULL        ,
                                             NULL         , NULL                ,  NULL        ,
                                             NULL         , NULL                ,  NULL        ,
											 NULL         , NULL                ,  NULL        ,
											 NULL         , NULL                ,  NULL        ,
											 NULL         , NULL                ,  @V_DATA     ,
											 NULL         , @V_NRLANCTONF OUTPUT,  @V_PRXLANCESTQ OUTPUT;

         /*Atualiza a CTRLAPURFAT com o numero da apuracao retroativa*/
         UPDATE CTRLAPURFAT
         SET CDFILIALRETRO   = @P_CDFILIAL,
             NRAPURFATRETRO  = @P_NEWAPURACFAT,
             DTAPURFATRETRO  = @P_DTPROC   
         WHERE
            CDFILIAL    = @P_CDFILIFATU AND
            NRAPURACFAT = @P_NRAPURACFAT;
         SET @V_CTRL_CORPO = 0;
      END;
      
      IF @V_CTRL_PRODUTO = 1 BEGIN
         IF @STIDTIPNFEMP = '1' BEGIN
            EXEC TEKNISA.GERA_NOTAFISCAL_PRODUTO @P_CDFILIFATU, @V_NRLANCTONF, @V_CDPRODPRESTSERV,
                                    @V_CDARVPROD, @V_NMPRODUTO,
                                    @CURS_TRAB_NREFETIVOSAPGD, @V_VRSERVICO;
         END ELSE BEGIN
            /*Identificador de utilizao do cdigo e nome do produto como cdigo e descrio para emisso*/
            IF @V_IDUTPROPEMIS = 'S' BEGIN
               SELECT @V_CDARVPROD = MAX(CDARVPROD), @V_NMPRODUTO = MAX(NMPRODUTO)
               FROM PRODUTO
               WHERE CDPRODUTO = @V_CDPRODUTO;

               EXEC TEKNISA.GERA_NOTAFISCAL_PRODUTO @P_CDFILIFATU, @V_NRLANCTONF, @V_CDPRODUTO,
                                       @V_CDARVPROD, @V_NMPRODUTO,
                                       @CURS_TRAB_NREFETIVOSAPGD, @V_VRSERVICO;
            END ELSE BEGIN
               EXEC TEKNISA.GERA_NOTAFISCAL_PRODUTO @P_CDFILIFATU, @V_NRLANCTONF, @V_CDPRODUTO,
                                       @V_CDSERVFILI, @V_NMSERVICO,
                                       @CURS_TRAB_NREFETIVOSAPGD, @V_VRSERVICO;
            END;
         END;
         SET @V_CTRL_PRODUTO = 0;
      END;

      SET @V_CDCLIENTE_OLD = @CURS_TRAB_CDCLIENTEAPGD;

   
   
   
      FETCH NEXT FROM CURS_TRAB INTO @CURS_TRAB_CDCLIENTEAPGD, @CURS_TRAB_CDSERVFILIAPGD, @CURS_TRAB_VRPRECUNITAPGD, 
                                     @CURS_TRAB_NRAPURACGD   , @CURS_TRAB_DTAPURACFATGD , @CURS_TRAB_NREFETIVOSAPGD;
   END;
   CLOSE CURS_TRAB;
   DEALLOCATE CURS_TRAB;
   
   IF @V_QTAPUR > 0 BEGIN
      EXEC TEKNISA.GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIFATU, @V_NRLANCTONF;

      UPDATE NOTAFISCAL
      SET CDFILIALRETRO = @P_CDFILIAL,
          NRAPURFATNFRETR = @P_NEWAPURACFAT
      WHERE CDFILIAL = /*P_CDFILIAL*/@P_CDFILIFATU AND
            NRLANCTONF = @V_NRLANCTONF;
      SET @P_PRXAPURACFAT = @P_NEWAPURACFAT;
   END;
   /* APAGA OS REGISTROS DA TRAB_APURAC_GD DE APURACOES ANTERIORES */
   DELETE FROM TRAB_APURAC_GD
   WHERE CDFILIALAPGD  = @P_CDFILIFATU  AND
         NRAPURACGD    = @P_NRAPURACFAT;
END;

GO

-- VERSAO --
EXEC ATUVEROBJ 'APURAC_RETROATIVO_GD','5.09.001';
GO
