/* Tabela GRUPOFISCAL: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela GRUPOFISCAL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela GRUPOFISCAL utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_GRUPOFISCAL' AND
                 TYPE   = 'TR'                  AND
	              U.UID  = O.UID                 AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_GRUPOFISCAL
GO


CREATE TRIGGER LOG_GER_GRUPOFISCAL
ON GRUPOFISCAL
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO           VARCHAR(40);
   DECLARE  @V_TIPO              VARCHAR(1);
   DECLARE  @V_ITPESQ            VARCHAR(40);
   DECLARE  @V_DESC              VARCHAR(300);
   DECLARE  @V_DTOPER            DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO       VARCHAR(1);
   DECLARE  @V_CDGRUPOFISC_OLD  VARCHAR(3);
   DECLARE  @V_DSGRUPOFISC_OLD  VARCHAR(30);
   DECLARE  @V_CDGRUPOFISC_NEW  VARCHAR(3);
   DECLARE  @V_DSGRUPOFISC_NEW  VARCHAR(30);
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      CDGRUPOFISC,
      DSGRUPOFISC,
      NULL,
      NULL
   FROM
      DELETED
   WHERE
      (CDGRUPOFISC) NOT IN (SELECT CDGRUPOFISC FROM INSERTED)
   UNION ALL

   SELECT
      'U' IDCOMANDO,
      DELETED.CDGRUPOFISC,
      DELETED.DSGRUPOFISC,
      INSERTED.CDGRUPOFISC,
      INSERTED.DSGRUPOFISC
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDGRUPOFISC = DELETED.CDGRUPOFISC
   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      INSERTED.CDGRUPOFISC,
      INSERTED.DSGRUPOFISC
   FROM
      INSERTED
   WHERE
       (CDGRUPOFISC) NOT IN (SELECT CDGRUPOFISC FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDGRUPOFISC_OLD,
                                 @V_DSGRUPOFISC_OLD,
                                 @V_CDGRUPOFISC_NEW,
                                 @V_DSGRUPOFISC_NEW;



   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_CDGRUPOFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod=' + @V_CDGRUPOFISC_OLD;
         END;

         IF @V_DSGRUPOFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Descr=' + @V_DSGRUPOFISC_OLD;
         END;

         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_CDGRUPOFISC_OLD;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (@V_CDGRUPOFISC_OLD <> @V_CDGRUPOFISC_NEW) OR
               (@V_DSGRUPOFISC_OLD <> @V_DSGRUPOFISC_NEW) BEGIN
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_CDGRUPOFISC_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_CDGRUPOFISC_NEW;
         END;
      END;

      IF @V_CDGRUPOFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Cod=' + @V_CDGRUPOFISC_NEW;
      END;

      IF @V_DSGRUPOFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Descr=' + @V_DSGRUPOFISC_NEW;
      END;
      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('GRUPOFISCAL',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                              @V_CDGRUPOFISC_OLD,
                              @V_DSGRUPOFISC_OLD,
                              @V_CDGRUPOFISC_NEW,
                              @V_DSGRUPOFISC_NEW;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_GRUPOFISCAL','4.11.105';
GO

